/*
		This shader will convert the incoming VBO to texture.
		That's it. Nothing fancy!
		
 		Matthias Hollnder 2008/2009
*/

// --------------------------------------------------
// shader definition
// --------------------------------------------------
#version 120
#extension GL_EXT_gpu_shader4 : enable

// --------------------------------------------------
// uniform variables:
// --------------------------------------------------
uniform int				iOutputSamplerSize;

// --------------------------------------------------
// varying variables:
// --------------------------------------------------
varying vec3			vVarColorVertex;
varying vec3			vVarColorNormal;

// --------------------------------------------------
// function to convert output position
// --------------------------------------------------
vec2 ConvertOutputPosition(in unsigned int uiIndex, in int iWrapSize)
{
		unsigned int uiWrap = unsigned int(iWrapSize);
		unsigned int uiY = uiIndex / uiWrap;
		
		float fX = float(uiIndex - (uiY*uiWrap));
		float fY = float(uiY);
		
		return vec2(fX, fY);
}

// --------------------------------------------------
// Vertex-Shader
// --------------------------------------------------
void main() {
		unsigned int uiVertexID = unsigned int( gl_VertexID );					// Vertex (ID) to process
		vVarColorVertex = gl_Vertex.xyz;
		vVarColorNormal = gl_Normal.xyz;

		vec2 vPos2D = ConvertOutputPosition( uiVertexID, iOutputSamplerSize );	// The position to write to
		vec4 vPos = vec4(vPos2D.xy, 0.0, 1.0);									// z=0.0, w=1.0
		
		gl_Position = (gl_ModelViewProjectionMatrix*vPos);
}
