/*
		This shader is currently not in use but shows different lighting techniques
		separated from the subdivision/visual smooth-surface shaders.
		
		Matthias Hollnder 2008/2009
*/

// --------------------------------------------------
// shader definition
// --------------------------------------------------
#version 120

// --------------------------------------------------
// Uniform variables:
// --------------------------------------------------
uniform int 		iLightingModel;							// A value to control the specular lighting model
uniform float 		fSurfaceSmoothness;


// --------------------------------------------------
// varying variables
// --------------------------------------------------
varying vec3 		V;										// Vertex in View-Space
varying vec3 		N;										// Normal of the Vertex
varying vec3 		vLightDir;								// Vec To Light

// --------------------------------------------------
// Vertex-Shader
// --------------------------------------------------
void main() {
		N = (gl_NormalMatrix * gl_Normal);
		V = (gl_ModelViewMatrix * gl_Vertex).xyz;
		vLightDir = gl_LightSource[0].position.xyz - V;
		
		gl_Position = ftransform();
}
